#ifndef PARTICLES2D_DRAW_SAMPLES_H
#define PARTICLES2D_DRAW_SAMPLES_H

#include "utils2D.h"

inline void DrawParticles_SET(UINT _iIdx, USHORT _iColor, USHORT * _pData)
{
      _pData[_iIdx] = _iColor;
}

inline void DrawParticles_SET_BLUR4(UINT _iIdx, USHORT _iColor, USHORT * _pData)
{
   DrawParticles_SET(_iIdx, _iColor, _pData);
   
   USHORT r2 = (_iColor >> 11) & 0x1F; 
   USHORT g2 = (_iColor >> 5) & 0x3F; 
   USHORT b2 = (_iColor >> 0) & 0x1F;           
   r2 >>= 1; g2 >>= 1; b2 >>= 1;
   USHORT iBlur4Col = COLOR_RGB16(r2, g2, b2);
   DrawParticles_SET(_iIdx + 1, iBlur4Col, _pData);
   DrawParticles_SET(_iIdx - 1, iBlur4Col, _pData);
   DrawParticles_SET(_iIdx + SCREEN_WIDTH, iBlur4Col, _pData);
   DrawParticles_SET(_iIdx - SCREEN_WIDTH, iBlur4Col, _pData);
}

inline void DrawParticles_SET_BLUR8(UINT _iIdx, USHORT _iColor, USHORT * _pData)
{
   DrawParticles_SET(_iIdx, _iColor, _pData);
   
   USHORT r2 = (_iColor >> 11) & 0x1F; 
   USHORT g2 = (_iColor >> 5) & 0x3F; 
   USHORT b2 = (_iColor >> 0) & 0x1F;           
   r2 >>= 1; g2 >>= 1; b2 >>= 1;
   USHORT iBlur4Col = COLOR_RGB16(r2, g2, b2);
   DrawParticles_SET(_iIdx + 1, iBlur4Col, _pData);
   DrawParticles_SET(_iIdx - 1, iBlur4Col, _pData);
   DrawParticles_SET(_iIdx + SCREEN_WIDTH, iBlur4Col, _pData);
   DrawParticles_SET(_iIdx - SCREEN_WIDTH, iBlur4Col, _pData);
   
   r2 >>= 1; g2 >>= 1; b2 >>= 1;
   USHORT iBlur8Col = COLOR_RGB16(r2, g2, b2);
   DrawParticles_SET(_iIdx + (-1 - SCREEN_WIDTH), iBlur8Col, _pData);
   DrawParticles_SET(_iIdx + (1 - SCREEN_WIDTH), iBlur8Col, _pData);
   DrawParticles_SET(_iIdx + (-1 + SCREEN_WIDTH), iBlur8Col, _pData);
   DrawParticles_SET(_iIdx + (1 + SCREEN_WIDTH), iBlur8Col, _pData);
}

#endif
