#ifndef PARTICLES3D_TYPE_H
#define PARTICLES3D_TYPE_H

#include "utils3D.h"

struct Element3D;
struct Particle3D;
struct Emiter3D;

typedef void (*Update3DParticleFct)(Emiter3D* _pEmiter, Particle3D* _pParticle, UINT _iCurTime, const fixed_t& _fElapsedTime);
typedef void (*Update3DEmiterFct)(Emiter3D* _pEmiter, UINT _iCurTime, const fixed_t& _fElapsedTime);
typedef void (*Draw3DParticleFct)(UINT _iIdx, fixed_t _fZ, USHORT _iColor, USHORT * _pData);

struct Element3D
{
       vec4x      m_3DPos;
       USHORT     m_3DColor;

       vec4x      m_2DPos;
       USHORT     m_2DColor;  
       bool       m_visible2D;
};

struct Particle3D
{
       void*      m_pUserData;

       UINT       m_iEndTime;
       Element3D* m_pElement;
};

struct Emiter3D
{
       void*      m_pUserData;

       UINT       m_iNbParticles;
       
       vec4x      m_vSource3DPos;
       fixed_t    m_fSourceSize;
       fixed_t    m_fFar;
       bool       m_visible3D;

       Element3D*   m_arrayElements;
       Particle3D*  m_arrayParticles;
       
       Update3DParticleFct   m_fctUpdateParticles;
       Update3DEmiterFct     m_fctUpdateEmiter;
};

struct Camera3D
{
       vec3x m_3DPos;
       mat4x m_matView;
       mat4x m_matProj;
       
       mat4x m_matViewProj;
};


#endif
