#ifndef PARTICULE_COMETE3D_H
#define PARTICULE_COMETE3D_H

#define COMETE3D_PARTICLE_MIN_DURATION      64
#define COMETE3D_PARTICLE_RAND_DURATION     256
static void  Comete3DParticlesInit(Emiter3D* _pEmiter)
{
   // USER DATA INIT
   vec4x* arrayParticleDir = new vec4x[_pEmiter->m_iNbParticles + 1];
   _pEmiter->m_pUserData = arrayParticleDir;
   
   Particle3D* pCurParticle = _pEmiter->m_arrayParticles;
   UINT iNbParticles = _pEmiter->m_iNbParticles;
   for (UINT i = iNbParticles; i != 0; --i)
   {
         pCurParticle->m_pUserData = arrayParticleDir + i;
         pCurParticle++;
   }
   *arrayParticleDir = vec4x(FIXED(1), FIXED(0), FIXED(0), FIXED(1));
}

static void Comete3DEmiters(Emiter3D* _pEmiter, UINT _iCurTime, const fixed_t& _fElapsedTime)
{
      LOGASSERT(_pEmiter != 0, "CometeEmiters : _pEmiter == NULL");
      
#define COMETE3D_SPEED FIXED(3)
      vec4x *pDir = ((vec4x*)_pEmiter->m_pUserData);
      _pEmiter->m_vSource3DPos += *pDir * _fElapsedTime * FIXED(1 + (rand() % 6));
      mat4<fixed_t> matRot = rotation_matrix_rad<fixed_t>(_fElapsedTime * COMETE3D_SPEED, vec3x(FIXED(0), FIXED(0), FIXED(1)));
      vec4x vRes = matRot * vec4x(*pDir);
      pDir->x = vRes.x;
      pDir->y = vRes.y;
      pDir->z = vRes.z;
      *pDir = normalize<fixed_t>(*pDir);
      pDir->x *= COMETE3D_SPEED;
      pDir->y *= COMETE3D_SPEED;
      pDir->z *= COMETE3D_SPEED;
}

static void Comete3DParticles(Emiter3D* _pEmiter, Particle3D* _pParticle, UINT _iCurTime, const fixed_t& _fElapsedTime)
{
      LOGASSERT(_pEmiter != 0, "CometeParticles : _pEmiter == NULL");
      LOGASSERT(_pParticle != 0, "CometeParticles : _pParticle == NULL");
      LOGASSERT(_pParticle->m_pElement != 0, "CometeParticles : _pParticle->m_pElement == NULL");
 
     Element3D * elm = _pParticle->m_pElement;
     
     if (_pParticle->m_iEndTime == 0)
     {
         // PARTICLE START
        LOGASSERT(_pParticle->m_pUserData != 0, "CometeParticles / INIT : _pParticle->m_pUserData == NULL");

        _pParticle->m_iEndTime = _iCurTime + COMETE3D_PARTICLE_MIN_DURATION + (rand() % COMETE3D_PARTICLE_RAND_DURATION);

        int dx, dy, dz;
        int r = rand();
        dx = (r & 0x1F);
        dy = ((r >> 5) & 0x1F);
        dz = ((r >> 10) & 0x1F);
        elm->m_3DColor = (dx << 0) | (dy << 6) | (dz << 11);
        elm->m_3DPos = _pEmiter->m_vSource3DPos + vec4x(FIXED(dx) * FIXED(0.03f), FIXED(dy) * FIXED(0.03f), FIXED(dz) * FIXED(0.03f), FIXED(0));
     }
     else
     {
         if (_pParticle->m_iEndTime < _iCurTime)
         {
            // RESTART            
            _pParticle->m_iEndTime = 0;
         }
         else
         {
            // UPDATE
         }
     }
}


#endif
