#include "fpsCounter.h"
#include "LogSystem.h"

#include <stdio.h>
#include <SDL.h>

#define  TIME_BEFORE_NEXT_FPS 1000

#ifdef GP2X
static UINT g_iLastFrameCount = 20;
#else
static UINT g_iLastFrameCount = 500;
#endif
static UINT g_iFrameCounter = 0;
static UINT g_iFrameCumulTime = 0;

void  UpdateFPS(UINT iElapsedTime)
{
   UINT iFrameCounter = g_iFrameCounter;
   UINT iFrameCumulTime = g_iFrameCumulTime;
   
   iFrameCounter++;
   iFrameCumulTime += iElapsedTime;
   if (iFrameCumulTime >= TIME_BEFORE_NEXT_FPS)
   {   
      UINT iLastFrameCount = g_iLastFrameCount;
      
      iLastFrameCount += iFrameCounter;
      iLastFrameCount /= 2;
      static char title[128];
   	sprintf(title, "PARTICLE : %d FPS", iLastFrameCount);
   	SDL_WM_SetCaption(title, NULL);
   	LogSystemOut(title);

      iFrameCounter = 0;
      iFrameCumulTime -= TIME_BEFORE_NEXT_FPS;

      g_iLastFrameCount = iLastFrameCount;
   }

   g_iFrameCounter = iFrameCounter;
   g_iFrameCumulTime = iFrameCumulTime;
}
