#ifndef PARTICLE2D_H
#define PARTICLE2D_H

#include "Particles2DTypes.h"

template<UINT NB_MAX_EMITERS, UINT NB_MAX_TOTAL_PARTICLES, DrawParticleFct FCT_DRAWPARTICLE> class ParticlePool
{
   public:
      
   inline ParticlePool();
   inline ~ParticlePool();
   
   inline Emiter*  AddEmiter(const vec2D& _vSourcePos, UINT _iNbParticles);
   inline void     RemoveEmiter(Emiter* _pEmiter); // DONT FORGET TO DELETE USER DATA IN EMITER BEFORE REMOVING

   inline void     DoAllWithoutDrawing(const Camera& _pCamera, UINT _iCurTime, UINT _fElapsedTime);
   inline void     DrawPool(USHORT* _pData);
   
   inline void     LogPool();

   private:
      
   inline void       DoEmiterCulling(Emiter * _pEmiter, const Camera & _pCamera);
   inline void       Element3Dto2D(Element* _arrayElements, UINT _iNbElements, const Camera& _pCamera);
   inline void       DrawElement(Element* _arrayElements, UINT _iNbElements, USHORT* _pData);
      
   inline void       AddEmiterSorted(Emiter * pEmiter);
      
   inline void       UpdateEmitersPool(const Camera& _pCamera, UINT _iCurTime, UINT _fElapsedTime);
   inline void       UpdateParticlesPool(const Camera& _pCamera, UINT _iCurTime, UINT _fElapsedTime);
   
   inline void       FreeEmiterPool(Emiter * _pEmiter);
   inline Emiter*    AllocEmiterPool(UINT _iNbParticles);
   inline void       FreeParticlePool(Particle* _pParticle);
   inline Particle*  AllocParticlePool(UINT _iNbParticles);

      struct
      {
         Element     m_arrayElementsPool[NB_MAX_TOTAL_PARTICLES];
         Particle    m_arrayParticlesPool[NB_MAX_TOTAL_PARTICLES];
         bool        m_arrayParticlesUse[NB_MAX_TOTAL_PARTICLES];
         UINT        m_arrayParticlesSize[NB_MAX_TOTAL_PARTICLES];
         Emiter      m_arrayEmitersPool[NB_MAX_EMITERS];
         bool        m_arrayEmitersUse[NB_MAX_EMITERS];
         Emiter*     m_arrayEmitersSorted[NB_MAX_EMITERS];
         UINT        m_nbEmitersToDisplay;
      }              m_Pool;      
};

#include "particle2D.inl"

#endif
