#ifndef UTILS2D_H
#define UTILS2D_H

#include "utils.h"

typedef struct vec2D
{
   int   x, y;

   vec2D() {x = 0; y = 0;};
   vec2D(int _x, int _y) {x = _x; y = _y;};
   vec2D(const vec2D & v) {x = v.x; y = v.y;};
   vec2D operator + (const vec2D & v) {vec2D res(v); res.x += x; res.y += y; return res;};
   vec2D operator += (const vec2D & v) {x += v.x; y += v.y; return *this;};
   vec2D operator - (const vec2D & v) {vec2D res(*this); res.x -= v.x; res.y -= v.y; return res;};
   vec2D operator -= (const vec2D & v) {x -= v.x; y -= v.y; return *this;};
   vec2D operator * (const vec2D & v) {vec2D res(v); res.x *= x; res.y *= y; return res;};
   vec2D operator *= (const vec2D & v) {x *= v.x; y *= v.y; return *this;};
   vec2D operator * (int v) {vec2D res(*this); res.x *= v; res.y *= v; return res;};
   vec2D operator *= (int v) {x *= v; y *= v; return *this;};
   vec2D operator / (const vec2D & v) {vec2D res(v); res.x /= x; res.y /= y; return res;};
   vec2D operator /= (const vec2D & v) {x /= v.x; y /= v.y; return *this;};
   vec2D operator / (int v) {vec2D res(*this); res.x /= v; res.y /= v; return res;};
   vec2D operator /= (int v) {x /= v; y /= v; return *this;};
};



#endif
